// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import AccountService from "../../../../../service/account/AccountService";
import SecurityService from "../../../../../service/security/SecurityService";
import { ProtectedTransferFromByPartitionCommand, ProtectedTransferFromByPartitionCommandResponse, } from "./ProtectedTransferFromByPartitionCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import { KycStatus } from "../../../../../../domain/context/kyc/Kyc";
import ValidationService from "../../../../../service/validation/ValidationService";
import ContractService from "../../../../../service/contract/ContractService";
import { ProtectedTransferFromByPartitionCommandError } from "./error/ProtectedTransferFromByPartitionCommandError";
let ProtectedTransferFromByPartitionCommandHandler = class ProtectedTransferFromByPartitionCommandHandler {
    securityService;
    accountService;
    transactionService;
    validationService;
    contractService;
    constructor(securityService, accountService, transactionService, validationService, contractService) {
        this.securityService = securityService;
        this.accountService = accountService;
        this.transactionService = transactionService;
        this.validationService = validationService;
        this.contractService = contractService;
    }
    async execute(command) {
        try {
            const { securityId, partitionId, sourceId, targetId, amount, deadline, nounce, signature } = command;
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            const security = await this.securityService.get(securityId);
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const sourceEvmAddress = await this.accountService.getAccountEvmAddress(sourceId);
            const targetEvmAddress = await this.accountService.getAccountEvmAddress(targetId);
            const amountBd = BigDecimal.fromString(amount, security.decimals);
            await this.validationService.checkPause(securityId);
            await this.validationService.checkProtectedPartitions(security);
            await this.validationService.checkProtectedPartitionRole(partitionId, account.id.toString(), securityId);
            await this.validationService.checkDecimals(security, amount);
            await this.validationService.checkKycAddresses(securityId, [sourceId, targetId], KycStatus.GRANTED);
            await this.validationService.checkControlList(securityId, sourceEvmAddress.toString(), targetEvmAddress.toString());
            await this.validationService.checkBalance(securityId, sourceId, amountBd);
            await this.validationService.checkValidNounce(securityId, sourceId, nounce);
            const res = await handler.protectedTransferFromByPartition(securityEvmAddress, partitionId, sourceEvmAddress, targetEvmAddress, amountBd, BigDecimal.fromString(deadline.substring(0, 10)), BigDecimal.fromString(nounce.toString()), signature, securityId);
            return Promise.resolve(new ProtectedTransferFromByPartitionCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new ProtectedTransferFromByPartitionCommandError(error);
        }
    }
};
ProtectedTransferFromByPartitionCommandHandler = __decorate([
    CommandHandler(ProtectedTransferFromByPartitionCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(AccountService)),
    __param(2, lazyInject(TransactionService)),
    __param(3, lazyInject(ValidationService)),
    __param(4, lazyInject(ContractService)),
    __metadata("design:paramtypes", [SecurityService,
        AccountService,
        TransactionService,
        ValidationService,
        ContractService])
], ProtectedTransferFromByPartitionCommandHandler);
export { ProtectedTransferFromByPartitionCommandHandler };
